function Facade(){}Facade.prototype.initialize=function(){this.initializeFacade();
return this;};Facade.prototype.view=null;Facade.prototype.model=null;Facade.prototype.controller=null;
Facade.prototype.initializeFacade=function(){this.initializeModel();this.initializeController();
this.initializeView();};Facade.prototype.initializeModel=function(){this.model=Model.getInstance();
};Facade.prototype.initializeController=function(){this.controller=Controller.getInstance();
};Facade.prototype.initializeView=function(){this.view=View.getInstance();};Facade.prototype.registerCommand=function(notificationName,commandClassRef){this.controller.registerCommand(notificationName,commandClassRef);
};Facade.prototype.removeCommand=function(notificationName){this.controller.removeCommand(notificationName);
};Facade.prototype.hasCommand=function(notificationName){return this.controller.hasCommand(notificationName);
},Facade.prototype.registerProxy=function(proxy){this.model.registerProxy(proxy);
};Facade.prototype.retrieveProxy=function(proxyName){return this.model.retrieveProxy(proxyName);
};Facade.prototype.removeProxy=function(proxyName){return this.model.removeProxy(proxyName);
};Facade.prototype.hasProxy=function(proxyName){return this.model.hasProxy(proxyName);
};Facade.prototype.registerMediator=function(mediator){this.view.registerMediator(mediator);
};Facade.prototype.retrieveMediator=function(mediatorName){return this.view.retrieveMediator(mediatorName);
};Facade.prototype.removeMediator=function(mediatorName){return this.view.removeMediator(mediatorName);
};Facade.prototype.hasMediator=function(mediatorName){return this.view.hasMediator(mediatorName);
};Facade.prototype.sendNotification=function(notificationName,body,type){this.notifyObservers(new Notification().initialize(notificationName,body,type));
};Facade.prototype.notifyObservers=function(notification){this.view.notifyObservers(notification);
};Facade.instance=null;Facade.getInstance=function(){if(!Facade.instance){Facade.instance=new Facade().initialize();
}return Facade.instance;};function Notification(){}Notification.prototype.initialize=function(name,body,type){this.name=name;
this.body=body;this.type=type;return this;};Notification.prototype.name=null;Notification.prototype.body=null;
Notification.prototype.type=null;Notification.prototype.getName=function(){return this.name;
};Notification.prototype.setBody=function(body){this.body=body;};Notification.prototype.getBody=function(){return this.body;
};Notification.prototype.setType=function(type){this.type=type;};Notification.prototype.getType=function(){return this.type;
};Notification.prototype.toString=function(){var msg="Notification Name: "+this.getName();
msg+="\nBody:"+((this.getBody()==null)?"null":this.getBody().toString());msg+="\nType:"+((this.getType()==null)?"null":this.getType());
return msg;};function Notifier(){}Notifier.prototype.initialize=function(){this.facade=Facade.getInstance();
return this;};Notifier.prototype.facade=null;Notifier.prototype.sendNotification=function(notificationName,body,type){this.facade.sendNotification(notificationName,body,type);
};function Observer(){}Observer.prototype.initialize=function(notifyMethod,notifyContext){this.setNotifyMethod(notifyMethod);
this.setNotifyContext(notifyContext);return this;};Observer.prototype.notify=null;
Observer.prototype.context=null;Observer.prototype.getNotifyMethod=function(){return this.notify;
};Observer.prototype.setNotifyMethod=function(notifyMethod){this.notify=notifyMethod;
};Observer.prototype.getNotifyContext=function(){return this.context;};Observer.prototype.setNotifyContext=function(notifyContext){this.context=notifyContext;
};Observer.prototype.notifyObserver=function(notification){this.getNotifyMethod().call(this.getNotifyContext(),notification);
};Observer.prototype.compareNotifyContext=function(object){return object===this.getNotifyContext();
};function Controller(){}Controller.prototype.initialize=function(){this.commandMap={};
this.initializeController();return this;};Controller.prototype.view=null;Controller.prototype.commandMap=null;
Controller.prototype.initializeController=function(){this.view=View.getInstance();
};Controller.prototype.executeCommand=function(note){var commandClassRef=this.commandMap[note.getName()];
if(commandClassRef){var command=new commandClassRef().initialize();command.execute(note);
}};Controller.prototype.registerCommand=function(notificationName,commandClassRef){if(!this.commandMap[notificationName]){var observer=new Observer().initialize(this.executeCommand,this);
this.view.registerObserver(notificationName,observer);}this.commandMap[notificationName]=commandClassRef;
};Controller.prototype.hasCommand=function(notificationName){return this.commandMap[notificationName]?true:false;
};Controller.prototype.removeCommand=function(notificationName){if(this.hasCommand(notificationName)){this.view.removeObserver(notificationName,this);
delete this.commandMap[notificationName];}};Controller.instance=null;Controller.getInstance=function(){if(!Controller.instance){Controller.instance=new Controller().initialize();
}return Controller.instance;};function Model(){}Model.prototype.initialize=function(){this.proxyMap={};
this.initializeModel();return this;};Model.prototype.proxyMap=null;Model.prototype.registerProxy=function(proxy){var name=proxy.getProxyName();
if(typeof name=="undefined"){return;}this.proxyMap[name]=proxy;proxy.onRegister();
},Model.prototype.retrieveProxy=function(proxyName){var proxy=this.proxyMap[proxyName];
return proxy?proxy:null;},Model.prototype.hasProxy=function(proxyName){return this.proxyMap[proxyName]?true:false;
},Model.prototype.removeProxy=function(proxyName){var proxy=this.proxyMap[proxyName];
if(!proxy){return null;}delete this.proxyMap[proxyName];proxy.onRemove();return proxy;
},Model.prototype.initializeModel=function(){};Model.instance=null;Model.getInstance=function(){if(!Model.instance){Model.instance=new Model().initialize();
}return Model.instance;};function View(){}View.prototype.initialize=function(){this.mediatorMap={};
this.observerMap={};this.initializeView();return this;};View.prototype.mediatorMap=null;
View.prototype.observerMap=null;View.prototype.initializeView=function(){};View.prototype.registerObserver=function(notificationName,observer){var observers=this.observerMap[notificationName];
if(observers){observers.push(observer);}else{this.observerMap[notificationName]=[observer];
}};View.prototype.notifyObservers=function(notification){var name=notification.getName();
if(this.observerMap[name]){var observers=this.observerMap[name].slice(0);var len=observers.length;
for(var i=0;i<len;i++){var observer=observers[i];observer.notifyObserver(notification);
}}};View.prototype.removeObserver=function(notificationName,notifyContext){var observers=this.observerMap[notificationName];
var i=observers.length;while(i--){var observer=observers[i];if(observer.compareNotifyContext(notifyContext)){observers.splice(i,1);
break;}}if(!observers.length){delete this.observerMap[notificationName];}};View.prototype.registerMediator=function(mediator){var name=mediator.getMediatorName();
if(this.mediatorMap[name]){return;}this.mediatorMap[name]=mediator;var interests=mediator.listNotificationInterests();
var len=interests.length;if(len){var observer=new Observer().initialize(mediator.handleNotification,mediator);
for(var i=0;i<len;i++){this.registerObserver(interests[i],observer);}}mediator.onRegister();
};View.prototype.retrieveMediator=function(mediatorName){var mediator=this.mediatorMap[mediatorName];
return mediator?mediator:null;};View.prototype.hasMediator=function(mediatorName){return this.mediatorMap[mediatorName]?true:false;
};View.prototype.removeMediator=function(mediatorName){var mediator=this.mediatorMap[mediatorName];
if(!mediator){return null;}var interests=mediator.listNotificationInterests();var i=interests.length;
while(i--){this.removeObserver(interests[i],mediator);}delete this.mediatorMap[mediatorName];
mediator.onRemove();return mediator;};View.instance=null;View.getInstance=function(){if(!View.instance){View.instance=new View().initialize();
}return View.instance;};function MacroCommand(){}MacroCommand.prototype=new Notifier();
MacroCommand.prototype.initialize=function(){Notifier.prototype.initialize.call(this);
this.subCommands=[];this.initializeMacroCommand();return this;};MacroCommand.prototype.subCommands=null;
MacroCommand.prototype.initializeMacroCommand=function(){};MacroCommand.prototype.addSubCommand=function(commandClassRef){this.subCommands.push(commandClassRef);
};MacroCommand.prototype.execute=function(notification){var len=this.subCommands.length;
for(var i=0;i<len;i++){var commandClassRef=this.subCommands[i];var commandInstance=new commandClassRef().initialize();
commandInstance.execute(notification);}};function SimpleCommand(){}SimpleCommand.prototype=new Notifier();
SimpleCommand.prototype.initialize=function(){Notifier.prototype.initialize.call(this);
return this;};SimpleCommand.prototype.execute=function(notification){};function Mediator(){}Mediator.prototype=new Notifier();
Mediator.prototype.initialize=function(mediatorName,viewComponent){Notifier.prototype.initialize.call(this);
this.mediatorName=(mediatorName!=null)?mediatorName:Mediator.NAME;this.viewComponent=viewComponent;
return this;};Mediator.prototype.mediatorName=null;Mediator.prototype.viewComponent=null;
Mediator.prototype.listNotificationInterests=function(){return[];};Mediator.prototype.getMediatorName=function(){return this.mediatorName;
};Mediator.prototype.getViewComponent=function(){return this.viewComponent;};Mediator.prototype.setViewComponent=function(viewComponent){this.viewComponent=viewComponent;
};Mediator.prototype.handleNotification=function(notification){};Mediator.prototype.onRegister=function(){};
Mediator.prototype.onRemove=function(){};Mediator.NAME="Mediator";function Proxy(){}Proxy.prototype=new Notifier();
Proxy.prototype.initialize=function(proxyName,data){Notifier.prototype.initialize.call(this);
this.proxyName=(proxyName!=null)?proxyName:Proxy.NAME;this.data=data;return this;
};Proxy.prototype.data=null;Proxy.prototype.proxyName=null;Proxy.prototype.getProxyName=function(){return this.proxyName;
};Proxy.prototype.setData=function(data){this.data=data;};Proxy.prototype.getData=function(){return this.data;
};Proxy.prototype.onRegister=function(){};Proxy.prototype.onRemove=function(){};Proxy.NAME="Proxy";
