/*
 PureMVC standard Javascript port by Frederic Saunier <frederic.saunier@puremvc.org>
 PureMVC - Copyright(c) 2006-2011 Futurescale, Inc., Some rights reserved.
 Your reuse is governed by the Creative Commons Attribution 3.0 License
*/

/**
 * @classDescription
 * A SimpleCommand subclass used by ControllerTest.
 *
 * @see org.puremvc.js.standard.core.controller.ControllerTest ControllerTest
 * @see org.puremvc.js.standard.core.controller.ControllerTestVO ControllerTestVO
 *
 * @extends org.puremvc.js.standard.core.controller.SimpleCommand SimpleCommand
 * 
 * @constructor
 */
function ControllerTestCommand(){}

/**
 * @extends org.puremvc.js.standard.core.controller.SimpleCommand SimpleCommand
 */
ControllerTestCommand.prototype = new SimpleCommand();

/**
 * @override
 * 
 * Initialize a <code>ControllerTestCommand</code> instance.
 * 
 * @return {ControllerTestCommand}
 * 		This <code>ControllerTestCommand</code> instance.
 */
ControllerTestCommand.prototype.initialize = function()
{
	SimpleCommand.prototype.initialize.call(this);

	return this;
}

/**
 * Fabricate a result by multiplying the input by 2.
 * 
 * @param {Notification} note
 * 		The note carrying the ControllerTestVO
 */
ControllerTestCommand.prototype.execute = function ( note/*Notification*/ ) 
{
	var vo/*ControllerTestVO*/ = note.getBody();

	// Fabricate a result
	vo.result = 2 * vo.input;
}