/*
 PureMVC standard Javascript port by Frederic Saunier Saunier <frederic.saunier@puremvc.org>
 PureMVC - Copyright(c) 2006-2011 Futurescale, Inc., Some rights reserved.
 Your reuse is governed by the Creative Commons Attribution 3.0 License
*/

/**
 * @classDescription
 * A SimpleCommand subclass used by ControllerTest.
 *
 * @see org.puremvc.js.standard.core.controller.ControllerTest ControllerTest
 * @see org.puremvc.js.standard.core.controller.ControllerTestVO ControllerTestVO
 *
 * @extends org.puremvc.js.standard.patterns.command.SimpleCommand SimpleCommand
 * 
 * @constructor
 */
function ControllerTestCommand2(){}

/**
 * @extends org.puremvc.js.standard.patterns.command.SimpleCommand SimpleCommand
 */
ControllerTestCommand2.prototype = new SimpleCommand();

/**
 * @override
 * 
 * Initialize a <code>ControllerTestCommand2</code> instance.
 * 
 * @return {ControllerTestCommand2}
 * 		This <code>ControllerTestCommand</code> instance.
 */
ControllerTestCommand2.prototype.initialize = function()
{
	return this;
}

/**
 * Fabricate a result by multiplying the input by 2 and adding to the
 * existing result.
 * 
 * <P>
 * This tests accumulation effect that would show if the command were
 * executed more than once.
 * 
 * @param {Notification} note 
 * 		The note carrying the ControllerTestVO.
 */
ControllerTestCommand2.prototype.execute = function( note ) 
{
	var vo/*ControllerTestVO*/ = note.getBody();
	
	// Fabricate a result
	vo.result = vo.result+(2 * vo.input);
}