/*
 PureMVC standard Javascript port by Frederic Saunier Saunier <frederic.saunier@puremvc.org>
 PureMVC - Copyright(c) 2006-2011 Futurescale, Inc., Some rights reserved.
 Your reuse is governed by the Creative Commons Attribution 3.0 License
*/

/**
 * A <code>Proxy</code> subclass used by <code>ModelTest</code> testCase.
 *
 * @extends org.puremvc.js.standard.patterns.proxy.Proxy Proxy
 * 
 * @constructor
 */
function ModelTestProxy(){}

/**
 * @extends org.puremvc.js.standard.patterns.proxy.Proxy Proxy
 */
ModelTestProxy.prototype = new Proxy();

/**
 * @override
 * 
 * Initialize a <code>ModelTestProxy</code> instance.
 * 
 * @return {ModelTestProxy}
 * 		This <code>ModelTestProxy</code> instance.
 */
ModelTestProxy.prototype.initialize = function()
{
	Proxy.prototype.initialize.call( this, ModelTestProxy.NAME, '' );

	return this;
}

/**
 * @override.
 */
ModelTestProxy.prototype.onRegister = function()
{
	this.setData( ModelTestProxy.ON_REGISTER_CALLED );
},		

/**
 * @override.
 */
ModelTestProxy.prototype.onRemove = function()
{
	this.setData( ModelTestProxy.ON_REMOVE_CALLED );
}

/**
 * @type {String}
 * @constant
 */
ModelTestProxy.NAME = 'ModelTestProxy';


/**
 * @type {String}
 * @constant
 */
ModelTestProxy.ON_REGISTER_CALLED = 'onRegister Called';


/**
 * @type {String}
 * @constant
 */
ModelTestProxy.ON_REMOVE_CALLED = 'onRemove Called';