/*
 PureMVC standard Javascript port by Frederic Saunier Saunier <frederic.saunier@puremvc.org>
 PureMVC - Copyright(c) 2006-2011 Futurescale, Inc., Some rights reserved.
 Your reuse is governed by the Creative Commons Attribution 3.0 License
*/

/**
 * @classDescription
 * A MacroCommand subclass used by MacroCommandTest.
 *
 * @see org.puremvc.js.standard.patterns.command.MacroCommandTest MacroCommandTest
 * @see org.puremvc.js.standard.patterns.command.MacroCommandTestSub1Command MacroCommandTestSub1Command
 * @see org.puremvc.js.standard.patterns.command.MacroCommandTestSub2Command MacroCommandTestSub2Command
 * @see org.puremvc.js.standard.patterns.command.MacroCommandTestVO MacroCommandTestVO
 * @extends org.puremvc.js.standard.patterns.command.MacroCommand MacroCommand
 * 
 * @constructor
 */
function MacroCommandTestCommand(){}

/**
 * @extends org.puremvc.js.standard.patterns.command.MacroCommand MacroCommand
 */
MacroCommandTestCommand.prototype = new MacroCommand();

/**
 * @override
 * 
 * Initialize a <code>MacroCommandTestCommand</code> instance.
 * 
 * @return {MacroCommandTestCommand}
 * 		This <code>MacroCommandTestCommand</code> instance.
 */
MacroCommandTestCommand.prototype.initialize = function()
{
	MacroCommand.prototype.initialize.call( this );

	return this;
}

/**
 * @override
 * 
 * Init the MacroCommandTestCommand by adding
 * its 2 SubCommands.
 */
MacroCommandTestCommand.prototype.initializeMacroCommand = function() 
{
	this.addSubCommand( MacroCommandTestSub1Command );
	this.addSubCommand( MacroCommandTestSub2Command );
}