/*
 PureMVC standard Javascript port by Frederic Saunier Saunier <frederic.saunier@puremvc.org>
 PureMVC - Copyright(c) 2006-2011 Futurescale, Inc., Some rights reserved.
 Your reuse is governed by the Creative Commons Attribution 3.0 License
*/

/**
 * @classDescription
 * A SimpleCommand subclass used by MacroCommandTestCommand.
 *
 * @see org.puremvc.js.standard.patterns.command.MacroCommandTest MacroCommandTest
 * @see org.puremvc.js.standard.patterns.command.MacroCommandTestCommand MacroCommandTestCommand
 * @see org.puremvc.js.standard.patterns.command.MacroCommandTestVO MacroCommandTestVO
 *
 * @extends org.puremvc.js.standard.patterns.command.SimpleCommand SimpleCommand
 * 
 * @constructor
 */
function MacroCommandTestSub1Command(){}

/**
 * @extends org.puremvc.js.standard.patterns.command.MacroCommand MacroCommand
 */
MacroCommandTestSub1Command.prototype = new SimpleCommand();

/**
 * @override
 * 
 * Initialize a <code>MacroCommandTestSub1Command</code> instance.
 * 
 * @return {MacroCommandTestSub1Command}
 * 		This <code>MacroCommandTestSub1Command</code> instance.
 */
MacroCommandTestSub1Command.prototype.initialize = function()
{
	SimpleCommand.prototype.initialize.call( this );

	return this;
}

/**
 * Fabricate a result by multiplying the input by 2
 * 
 * @param {Notification} note
 * 		The <code>Notification</code> carrying the
 * 		<code>MacroCommandTestVO</code>
 */
MacroCommandTestSub1Command.prototype.execute = function( note ) 
{
	var vo/*MacroCommandTestVO*/ = note.getBody();
	
	// Fabricate a result
	vo.result1 = 2 * vo.input;
}