/*
 PureMVC standard Javascript port by Frederic Saunier Saunier <frederic.saunier@puremvc.org>
 PureMVC - Copyright(c) 2006-2011 Futurescale, Inc., Some rights reserved.
 Your reuse is governed by the Creative Commons Attribution 3.0 License
*/

/**
 * @classDescription
 * A SimpleCommand subclass used by MacroCommandTestCommand.
 *
 * @see org.puremvc.js.standard.patterns.command.MacroCommandTest MacroCommandTest
 * @see org.puremvc.js.standard.patterns.command.MacroCommandTestCommand MacroCommandTestCommand
 * @see org.puremvc.js.standard.patterns.command.MacroCommandTestVO MacroCommandTestVO 
 *
 * @extends org.puremvc.js.standard.patterns.command.SimpleCommand SimpleCommand
 * 
 * @constructor
 */
function MacroCommandTestSub2Command(){}

/**
 * @extends org.puremvc.js.standard.patterns.command.SimpleCommand SimpleCommand
 */
MacroCommandTestSub2Command.prototype = new SimpleCommand();

/**
 * @override
 * 
 * Initialize a <code>MacroCommandTestSub2Command</code> instance.
 * 
 * @return {MacroCommandTestSub2Command}
 * 		This <code>MacroCommandTestSub2Command</code> instance.
 */
MacroCommandTestSub2Command.prototype.initialize = function()
{
	SimpleCommand.prototype.initialize.call( this );

	return this;
}

/**
 * Fabricate a result by multiplying the input by itself
 * 
 * @param {Notification} note
 * 		The <code>Notification</code> carrying the
 * 		<code>MacroCommandTestVO</code>
 */
MacroCommandTestSub2Command.prototype.execute= function( note ) 
{
	var vo/*MacroCommandTestVO*/ = note.getBody();
	
	// Fabricate a result
	vo.result2 = vo.input * vo.input;
}