/*
 PureMVC standard Javascript port by Frederic Saunier Saunier <frederic.saunier@puremvc.org>
 PureMVC - Copyright(c) 2006-2011 Futurescale, Inc., Some rights reserved.
 Your reuse is governed by the Creative Commons Attribution 3.0 License
*/

/**
 * @classDescription
 * A utility class used by MacroCommandTest.
 * 
 * @see org.puremvc.js.standard.patterns.command.MacroCommandTest MacroCommandTest
 * @see org.puremvc.js.standard.patterns.command.MacroCommandTestCommand MacroCommandTestCommand
 * @see org.puremvc.js.standard.patterns.command.MacroCommandTestSub1Command MacroCommandTestSub1Command
 * @see org.puremvc.js.standard.patterns.command.MacroCommandTestSub2Command MacroCommandTestSub2Command
 * 
 * @constructor
 */
function MacroCommandTestVO(){}

/**
 * Initialize a <code>MacroCommandTestVO</code> instance.
 * 
 * @param {Number} input
 * 		A random number to pass to the command.
 * 
 * @return {MacroCommandTestVO}
 * 		This <code>MacroCommandTestVO</code> instance.
 */
MacroCommandTestVO.prototype.initialize = function( input )
{
	this.input = input;
	
	return this;
}

/**
 * @type {Number}
 */
MacroCommandTestVO.prototype.input = null;

/**
 * @type {Number}
 */
MacroCommandTestVO.prototype.result1 = null;

/**
 * @type {Number}
 */
MacroCommandTestVO.prototype.result2 = null;