/*
 PureMVC standard Javascript port by Frederic Saunier Saunier <frederic.saunier@puremvc.org>
 PureMVC - Copyright(c) 2006-2011 Futurescale, Inc., Some rights reserved.
 Your reuse is governed by the Creative Commons Attribution 3.0 License
*/

/**
 * @classDescription
 * A SimpleCommand subclass used by SimpleCommandTest.
 *
 * @see org.puremvc.js.standard.patterns.command.SimpleCommandTest SimpleCommandTest
 * @see org.puremvc.js.standard.patterns.command.SimpleCommandTestVO SimpleCommandTestVO
 *
 * @extends org.puremvc.js.standard.patterns.command.SimpleCommand SimpleCommand
 * 
 * @constructor
 */
function SimpleCommandTestCommand(){}

/**
 * @extends org.puremvc.js.standard.patterns.command.SimpleCommand SimpleCommand
 */
SimpleCommandTestCommand.prototype = new SimpleCommand();

/**
 * @override
 * 
 * Initialize a <code>SimpleCommandTestCommand</code> instance.
 * 
 * @return {SimpleCommandTestCommand}
 * 		This <code>SimpleCommandTestCommand</code> instance.
 */
SimpleCommandTestCommand.prototype.initialize = function()
{
	SimpleCommand.prototype.initialize.call(this);
	
	return this;
}

/**
 * Fabricate a result by multiplying the input by 2
 * 
 * @param {Notification} note
 * 		The <code>Notification</code> carrying the
 * 		<code>SimpleCommandTestVO</code>
 */
SimpleCommandTestCommand.prototype.execute = function( note ) 
{
	var vo/*SimpleCommandTestVO*/ = note.getBody();

	// Fabricate a result
	vo.result = 2 * vo.input;
}