/*
 PureMVC standard Javascript port by Frederic Saunier Saunier <frederic.saunier@puremvc.org>
 PureMVC - Copyright(c) 2006-2011 Futurescale, Inc., Some rights reserved.
 Your reuse is governed by the Creative Commons Attribution 3.0 License
*/

/**
 * @classDescription
 * A <code>SimpleCommand</code> utility subclass used by
 * <code>SimpleCommandTest</code>.
 * 
 * @extends org.puremvc.js.standard.patterns.command.SimpleCommand SimpleCommand
 * 
 * @constructor
 */
function SimpleCommandTestSub(){}

/**
 * @extends org.puremvc.js.standard.patterns.command.SimpleCommand SimpleCommand
 */
SimpleCommandTestSub.prototype = new Mediator();

/**
 * @override
 * 
 * Initialize a <code>SimpleCommandTestSub</code> instance.
 * 
 * @return {SimpleCommandTestSub}
 * 		This <code>SimpleCommandTestSub</code> instance.
 */
SimpleCommandTestSub.prototype.initialize = function()
{
	SimpleCommand.prototype.initialize.call(this);
	
	return this;
}

/**
 * A method to test if <code>Facade</code> instance of the object has
 * well been declared during its construction.
 * 
 * @return {Boolean}
 * 		<code>Facade</code> instance of the object has well been declared
 * 		during its construction.
 */
SimpleCommandTestSub.prototype.hasFacade = function()/*Boolean*/
{
	return this.facade instanceof Facade;
}