/*
 PureMVC standard Javascript port by Frederic Saunier Saunier <frederic.saunier@puremvc.org>
 PureMVC - Copyright(c) 2006-2011 Futurescale, Inc., Some rights reserved.
 Your reuse is governed by the Creative Commons Attribution 3.0 License
*/

/**
 * @classDescription
 * A SimpleCommand subclass used by FacadeTest.
 *
 * @see org.puremvc.js.standard.patterns.facade.FacadeTest FacadeTest
 * @see org.puremvc.js.standard.patterns.facade.FacadeTestVO FacadeTestVO
 * 
 * @extends org.puremvc.js.standard.patterns.command.SimpleCommand SimpleCommand
 *
 * @constructor
 */
function FacadeTestCommand(){}

FacadeTestCommand.prototype = new SimpleCommand();

/**
 * @override
 * 
 * Initialize a <code>FacadeTestCommand</code> instance.
 * 
 * @return {FacadeTestCommand}
 * 		This <code>FacadeTestCommand</code> instance.
 */
FacadeTestCommand.prototype.initialize = function()
{
	SimpleCommand.prototype.initialize.call(this);
	
	return this;
}

/**
 * Fabricate a result by multiplying the input by 2
 * 
 * @param {Notification} note
 * 		The Notification carrying the FacadeTestVO
 */
FacadeTestCommand.prototype.execute = function( note ) 
{
	var vo/*FacadeTestVO*/ = note.getBody();
	
	// Fabricate a result
	vo.result = 2 * vo.input;
}