/*
 PureMVC standard Javascript port by Frederic Saunier Saunier <frederic.saunier@puremvc.org>
 PureMVC - Copyright(c) 2006-2011 Futurescale, Inc., Some rights reserved.
 Your reuse is governed by the Creative Commons Attribution 3.0 License
*/

/**
 * @classDescription
 * A utility class used by FacadeTest.
 * 
 * @see org.puremvc.js.standard.patterns.facade.FacadeTest FacadeTest
 * @see org.puremvc.js.standard.patterns.facade.FacadeTestCommand FacadeTestCommand
 * 
 * @constructor
 */
function FacadeTestVO(){}

/**
 * Initialize a <code>FacadeTestVO</code> instance.
 * 
 * @param {Number} input
 * 		The number to be fed to the <code>FacadeTestCommand</code>
 * 
 * @return {FacadeTestVO}
 * 		This <code>FacadeTestVO</code> instance.
 */
FacadeTestVO.prototype.initialize = function( input )
{
	this.input = input;
	
	return this;
}

/**
 * @type {Number}
 */
FacadeTestVO.prototype.input = null;

/**
 * @type {Number}
 */
FacadeTestVO.prototype.result = null;