/*
 PureMVC standard Javascript port by Frederic Saunier Saunier <frederic.saunier@puremvc.org>
 PureMVC - Copyright(c) 2006-2011 Futurescale, Inc., Some rights reserved.
 Your reuse is governed by the Creative Commons Attribution 3.0 License
*/

/**
 * @classDescription
 * A <code>Mediator</code> utility subclass used by <code>MediatorTest</code>.
 * 
 * @extends org.puremvc.js.standard.patterns.mediator.Mediator Mediator
 * 
 * @constructor
 */
function MediatorTestSub(){}

/**
 * @extends org.puremvc.js.standard.patterns.mediator.Mediator Mediator
 */
MediatorTestSub.prototype = new Mediator();

/**
 * @override
 * 
 * Initialize a <code>MediatorTestSub</code> instance.
 * 
 * @return {MediatorTestSub}
 * 		This <code>MediatorTestSub</code> instance.
 */
MediatorTestSub.prototype.initialize = function()
{
	Mediator.prototype.initialize.call(this);

	return this;
}

/**
 * A method to test if <code>Facade</code> instance of the object has
 * well been declared during its construction.
 * 
 * @return {Boolean}
 * 		<code>Facade</code> instance of the object has well been declared
 * 		during its construction.
 */
MediatorTestSub.prototype.hasFacade = function()/*Boolean*/
{
	return this.facade instanceof Facade;
}