/*
 PureMVC standard Javascript port by Frederic Saunier Saunier <frederic.saunier@puremvc.org>
 PureMVC - Copyright(c) 2006-2011 Futurescale, Inc., Some rights reserved.
 Your reuse is governed by the Creative Commons Attribution 3.0 License
*/

/**
 * @classDescription
 * A SimpleCommand subclass used by NotifierTest.
 *
 * @see org.puremvc.js.standard.patterns.observer.NotifierTest NotifierTest
 * @see org.puremvc.js.standard.patterns.observer.NotifierTestVO NotifierTestVO
 * 
 * @extends org.puremvc.js.standard.patterns.command.SimpleCommand SimpleCommand
 * 
 * @constructor
 */
function NotifierTestCommand(){}

/** 
 * @extends org.puremvc.js.standard.patterns.command.SimpleCommand SimpleCommand
 */
NotifierTestCommand.prototype = new SimpleCommand();

/**
 * @override
 * 
 * Initialize a <code>NotifierTestCommand</code> instance.
 * 
 * @return {NotifierTestCommand}
 * 		This <code>NotifierTestCommand</code> instance.
 */
NotifierTestCommand.prototype.initialize = function()
{
	SimpleCommand.prototype.initialize.call(this);

	return this;
}

/**
 * Fabricate a result by multiplying the input by 2
 * 
 * @param {Notification} note
 * 		The Notification carrying the NotifierTestVO
 */
NotifierTestCommand.prototype.execute= function( note ) 
{
	var vo/*NotifierTestVO*/ = note.getBody();
	
	// Fabricate a result
	vo.result = 2 * vo.input;
}