/*
 PureMVC standard Javascript port by Frederic Saunier Saunier <frederic.saunier@puremvc.org>
 PureMVC - Copyright(c) 2006-2011 Futurescale, Inc., Some rights reserved.
 Your reuse is governed by the Creative Commons Attribution 3.0 License
*/

/**
 * @classDescription
 * A <code>Notifier</code> utility subclass used by <code>NotifierTest</code>.
 * 
 * @extends org.puremvc.js.standard.patterns.observer.Notifier Notifier
 * 
 * @constructor
 */
function NotifierTestSub(){}

/**
 * @extends org.puremvc.js.standard.patterns.observer.Notifier Notifier
 */
NotifierTestSub.prototype = new Notifier();

/**
 * @override
 * 
 * Initialize a <code>NotifierTestSub</code> instance.
 * 
 * @return {NotifierTestSub}
 * 		This <code>NotifierTestSub</code> instance.
 */
NotifierTestSub.prototype.initialize = function()
{
	Notifier.prototype.initialize.call(this);

	return this;
}

/**
 * A method to test if <code>Facade</code> instance of the object has
 * well been declared during its construction.
 * 
 * @return {Boolean}
 * 		<code>Facade</code> instance of the object has well been declared
 * 		during its construction.
 */
NotifierTestSub.prototype.hasFacade= function()/*Boolean*/
{
	return this.facade instanceof Facade;
}