/*
 PureMVC PrototypeJS Javascript port by Frederic Saunier Saunier <frederic.saunier@puremvc.org>
 PureMVC - Copyright(c) 2006-2011 Futurescale, Inc., Some rights reserved.
 Your reuse is governed by the Creative Commons Attribution 3.0 License
*/

/**
 * @classDescription
 * A <code>Proxy</code> utility subclass used by <code>ProxyTest</code>.
 * 
 * @extends org.puremvc.js.standard.patterns.proxy.Proxy Proxy
 * 
 * @constructor
 */
function ProxyTestSub(){}

/**
 * @extends org.puremvc.js.standard.patterns.proxy.Proxy Proxy
 */
ProxyTestSub.prototype = new Proxy();

/**
 * @override
 * 
 * Initialize a <code>ProxyTestSub</code> instance.
 * 
 * @return {ProxyTestSub}
 * 		This <code>ProxyTestSub</code> instance.
 */
ProxyTestSub.prototype.initialize = function()
{
	Proxy.prototype.initialize.call(this);

	return this;
}

/**
 * A method to test if <code>Facade</code> instance of the object has
 * well been declared during its construction.
 * 
 * @return {Boolean}
 * 		<code>Facade</code> instance of the object has well been declared
 * 		during its construction.
 */
ProxyTestSub.prototype.hasFacade = function()/*Boolean*/
{
	return this.facade instanceof Facade;
}